;---------------------------------------------------------------
; Codec Windows-1251
;  Windows-1251
;---------------------------------------------------------------

comment * ======================================================

                     
                             MASM32

  . ():
ml /c /coff "console.asm"
PoLink /SUBSYSTEM:CONSOLE "console.obj"

: procs-list-close v.1.00 beta
:  ..
 2020

 . Freeware, OpenSource. " ".
sadovoya@mtu-net.ru
sadovoya.narod.ru


================================================================ *

.486
.model flat,stdcall
option casemap :none   

include \masm32\include\windows.inc   
include \masm32\include\user32.inc   ; CharToOem(),...
include \masm32\include\kernel32.inc ; Process32Next(), Process32First()
include \masm32\include\masm32.inc   ; print  
include \masm32\include\msvcrt.inc   ; printf(), crt_scanf,...

include \masm32\macros\macros.asm

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\masm32.lib
includelib \masm32\lib\msvcrt.lib

;--------------------------------------------------------------------------------
;https://stackoverflow.com/questions/44302121/masm32-process32firstw-not-working
PROCESSENTRY32W STRUCT
    dwSize              DWORD ?
    cntUsage            DWORD ?
    th32ProcessID       DWORD ?
    th32DefaultHeapID   DWORD ?
    th32ModuleID        DWORD ?
    cntThreads          DWORD ?
    th32ParentProcessID DWORD ?
    pcPriClassBase      DWORD ?
    dwFlags             DWORD ?
    szExeFile           dw MAX_PATH dup(?)
PROCESSENTRY32W ENDS
;----------------------------------------------------------------------------------


GetListOrTerminate PROTO :DWORD ;       
                                ; (  name.exe),   ;
                                ;   ,   "none"


.data
    ConsoleCaption db '   ',0
    PROMPT db '  - 1',13,10,'  - 2',13,10
           db ' - 0',13,10,': ',0
    IntFmt db '%d',0
    NONE db 'none',0
    AskName db ' : ',0
    StrFmt db '%s',0
    ErrClose db '   %s',13,10,0
    OkClose db ' %s ',13,10,0

.data?
    Buffer db 512 dup(?) ;  
    Choise dd ?
    NamePr db 80 dup(?) 

.code

start:
    ;  
    invoke CharToOem, offset ConsoleCaption, offset Buffer
    SetConsoleCaption offset Buffer

    .while 1
        invoke CharToOemA, offset PROMPT, offset Buffer
        print offset Buffer
        invoke crt_scanf, offset IntFmt, offset Choise
        switch Choise
            case 1
                invoke GetListOrTerminate, offset NONE 
            case 2
                invoke CharToOemA, offset AskName, offset Buffer
                print offset Buffer
                invoke crt_scanf, offset StrFmt, offset NamePr
                invoke GetListOrTerminate, ADDR NamePr   
            case 0
                ret
        endsw
        printf("\n")
    .endw


GetListOrTerminate proc proc_name:DWORD

    LOCAL hProcessSnap : HANDLE
    LOCAL pe32         : PROCESSENTRY32W
    LOCAL hProcess     : HANDLE

    printf("\n")

    invoke CreateToolhelp32Snapshot, TH32CS_SNAPPROCESS, 0
    .if eax == INVALID_HANDLE_VALUE
        ret        
    .endif 
    mov hProcessSnap, eax

    mov pe32.dwSize, sizeof pe32
    invoke Process32FirstW, hProcessSnap, ADDR pe32
    .if eax == 0
        invoke CloseHandle, hProcessSnap
        ret
    .endif

    .repeat 
        invoke crt_strcmp, ADDR NONE, proc_name  
        .if eax == 0    
            invoke CharToOemW, ADDR pe32.szExeFile, offset Buffer
            print offset Buffer, 13, 10
        .else
            invoke OemToCharW, proc_name, offset Buffer
            invoke crt_wcscmp, ADDR pe32.szExeFile, offset Buffer
            .if eax == 0
                mov hProcess, 0
                invoke OpenProcess, PROCESS_ALL_ACCESS, FALSE, pe32.th32ProcessID
                mov hProcess, eax
                invoke TerminateProcess, hProcess, 0
                .if eax == 0
                    invoke CharToOemA, offset ErrClose, offset Buffer
                    printf(offset Buffer, proc_name)
                .else                    
                    invoke CharToOemA, offset OkClose, offset Buffer
                    printf(offset Buffer, proc_name) 
                .endif
                .if hProcess != 0 
                    invoke CloseHandle, hProcess ; 
                .endif 
            .endif
        .endif
        invoke Process32NextW, hProcessSnap, ADDR pe32
    .until eax == 0

    invoke CloseHandle, hProcessSnap
	
    ret

GetListOrTerminate endp

end start
